' ======= KONFIGURATION =======
ordner    = "SZ"
' =============================
Const xlVAlignTop = -4160
Const xlThick = 4
Const xlEdgeTop = 8
Const xlDouble = 9
Const msoLineThinThin = 2
Const xlThin = 2
Const xlEdgeBottom = 9

Const perspFaktor = 2000

Set InternetExplorer = CreateObject("internetexplorer.application")

InternetExplorer.navigate2 "about:blank"
InternetExplorer.width = 400
InternetExplorer.height = 600
InternetExplorer.toolbar = false
InternetExplorer.menubar = false
InternetExplorer.statusbar = false
InternetExplorer.visible = True

statusText = "<p style='color:#003366'>Exportiere Uebersichtsdaten 1.2  - " &  Date & "</p>"

SetStatusText(statusText & "Initialisiere..")

scriptPath = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(".")
basePath =  scriptPath & "\" & ordner

Set folder = CreateObject("Scripting.FileSystemObject").GetFolder(basePath)

numberOfExcelFiles = 0
For each excelFile in folder.Files
  If  (isExcelFile(excelFile.Name)) Then
    numberOfExcelFiles = numberOfExcelFiles + 1
  End If
Next

Dim excelFiles()
ReDim excelFiles(numberOfExcelFiles - 1)

i = 0
For each excelFile in folder.Files
  If (isExcelFile(excelFile.Name)) Then
    excelFiles(i) = CStr(excelFile.Name)
    i = i + 1
  End If
Next


Set excel = CreateObject("Excel.Application")
Set overView = setUpExcelFile(excel, numberOfExcelFiles)
Set overViewSheet = overView.Worksheets.Item(1)
Dim Nr
Nr = 2
For each excelFile in SortArray(excelFiles)
	Set workbook = excel.Workbooks.Open(basePath & "\" & excelFile)
	 gdeNr =workbook.Sheets("Bevlkerungsdaten").Range("B5").Value
	 gdeName = workbook.Sheets("Bevlkerungsdaten").Range("C5").Value
	 
	 percent = Round(100*((Nr-2)/numberOfExcelFiles),1)
	 statusText = statusText & percent&"% - Gemeinde <strong>" & gdeName & "</strong>     " & "<br/>"
    SetStatusText(statusText)
    
	 perspNat = workbook.Sheets("Perspektive_nat_Entwicklung ").Range("E11").Value
	 perspOpt = workbook.Sheets("Optimistischer Trend").Range("E11").Value
	 perspPes = workbook.Sheets("Pessimistischer Trend").Range("E11").Value
	 saldoOpt = workbook.Sheets("Daten_BFS").Range("M28").Value
	 saldoPes = workbook.Sheets("Daten_BFS").Range("M32").Value
	
	overViewSheet.Range(overViewSheet.Cells(Nr,1),overViewSheet.Cells(Nr,1)).Value = gdeNr
	overViewSheet.Range(overViewSheet.Cells(Nr,2),overViewSheet.Cells(Nr,2)).Value = gdeName
	overViewSheet.Range(overViewSheet.Cells(Nr,3),overViewSheet.Cells(Nr,3)).Value = perspNat*perspFaktor
	overViewSheet.Range(overViewSheet.Cells(Nr,4),overViewSheet.Cells(Nr,4)).Value = perspOpt*perspFaktor
	overViewSheet.Range(overViewSheet.Cells(Nr,6),overViewSheet.Cells(Nr,6)).Value = perspPes*perspFaktor
	overViewSheet.Range(overViewSheet.Cells(Nr,7),overViewSheet.Cells(Nr,7)).Value = saldoOpt
	overViewSheet.Range(overViewSheet.Cells(Nr,8),overViewSheet.Cells(Nr,8)).Value = getCorresponding(saldoOpt)
	overViewSheet.Range(overViewSheet.Cells(Nr,11),overViewSheet.Cells(Nr,11)).Value = saldoPes
	overViewSheet.Range(overViewSheet.Cells(Nr,12),overViewSheet.Cells(Nr,12)).Value = getCorresponding(saldoPes)
	perspMittel = Empty
	saldoMittel = Empty
	On Error Resume Next
		perspMittel = workbook.Sheets("Mittlerer Trend").Range("E11").Value
		saldoMittel = workbook.Sheets("Daten_BFS").Range("M25").Value
		If(perspMittel <> Empty) then
		overViewSheet.Range(overViewSheet.Cells(Nr,5),overViewSheet.Cells(Nr,5)).Value = perspMittel*perspFaktor
		overViewSheet.Range(overViewSheet.Cells(Nr,9),overViewSheet.Cells(Nr,9)).Value = saldoMittel
		overViewSheet.Range(overViewSheet.Cells(Nr,10),overViewSheet.Cells(Nr,10)).Value = getCorresponding(saldoMittel)
		End If
	On Error GoTo 0
	Nr = Nr +1
	workbook.Close False
Next

SetStatusText(statusText&"</br><strong>100% - Finished </strong>")

overView.SaveAs(scriptPath+"\UebersichtGde_"+ordner+".xlsx")

overView.Close (SaveChanges = False)


'InternetExplorer.Quit

excel.Quit

'subs
Sub SetStatusText(text)
  InternetExplorer.Document.Body.InnerHTML = text
End Sub

Function isExcelFile(name)
	nameArray = Split(name, ".", -1, vbBinaryCompare)
	cond = InStr(1,nameArray( UBound(nameArray)),"xls", vbTextCompare)
	startChars = Left(nameArray(0),2)
	isExcelFile = (cond<>0)and(startChars<>"~$")
End Function

Function setUpExcelFile(excel, numberOfExcelFiles)
Set overView = excel.Workbooks.Add
Set overViewSheet = overView.Worksheets.Item(1)
For row = 1 To 12
		Set theRange = overViewSheet.Range(overViewSheet.Cells(1,row),overViewSheet.Cells(1,row))
		With theRange
			.WrapText = True
			.ColumnWidth = 12.3
			.RowHeight = 50.0
			.VerticalAlignment = xlVAlignTop
			.Borders(xlEdgeTop).Weight = xlThick
			.Borders(xlEdgeBottom).Weight = xlThin
			.Borders(xlEdgeBottom).LineStyle = xlDouble
		End With
		overViewSheet.Cells.Font.Name = "Arial Narrow"
Next
overViewSHeet.Range("A1").Value = "Gde_nr_BFS"
overViewSHeet.Range("B1").Value = "Gde_name"
overViewSHeet.Range("C1").Value = "GZ natrliche Entwicklung"
overViewSHeet.Range("D1").Value = "GZ optimistische Entwicklung"
overViewSHeet.Range("E1").Value = "GZ mittlere Entwicklung"
overViewSHeet.Range("F1").Value = "GZ pessimistische Entwicklung"
overViewSHeet.Range("G1").Value = "Wanderungssaldo optimistisch"
overViewSHeet.Range("H1").Value = "Entspricht dem jhrigen Durchschnitt"
overViewSHeet.Range("I1").Value = "Mittleres Wanderungssaldo"
overViewSHeet.Range("J1").Value = "Entspricht dem jhrigen Durchschnitt"
overViewSHeet.Range("K1").Value = "Wanderungssaldo pessimistisch"
overViewSHeet.Range("L1").Value = "Entspricht dem jhrigen Durchschnitt"

overViewSheet.Range(overViewSheet.Cells(2,3), overViewSheet.Cells(3+numberOfExcelFiles,6)).NumberFormat = "0.00"
overViewSheet.Range(overViewSheet.Cells(2,3), overViewSheet.Cells(3+numberOfExcelFiles,12)).HorizontalAlignment = 3

Set setUpExcelFile = overView
End Function

Function getCorresponding (saldo)
	fiveY = workbook.Sheets("Daten_BFS").Range("K50")
	fiveY = RoundIt(fiveY)
	tenY = (workbook.Sheets("Daten_BFS").Range("M50"))
	tenY = RoundIt(tenY)
	twentyY = workbook.Sheets("Daten_BFS").Range("P37")
	twentyY = RoundIt(twentyY)
	

	Select Case saldo
	Case fiveY
		getCorresponding = 5
	Case tenY
		getCorresponding = 10
	Case twentyY
		getCorresponding = 20
	End Select
End Function

Function SortArray(arrShort)
  dim i, j, temp
  for i = UBound(arrShort) - 1 To 0 Step -1
    for j= 0 to i
      if arrShort(j)>arrShort(j+1) then
        temp=arrShort(j+1)
        arrShort(j+1)=arrShort(j)
        arrShort(j)=temp
      end if
    next
  next
  SortArray = arrShort
end Function

Function RoundIt(number) 
	If(number < 0) then
		
	number = number-0.0001
		
	End if
	RoundIt = Round(number)
End Function